SET NOCOUNT ON
USE Northwind
BEGIN TRAN  -- So we can undo all this

-- Drop the index so we can see the effects of paritioning more easily
DROP INDEX Orders.OrderDate  

SELECT *
INTO P199701_Orders
FROM Orders
WHERE OrderDate BETWEEN '19970101' AND '19970131'

SELECT *
INTO P199702_Orders
FROM Orders
WHERE OrderDate BETWEEN '19970201' AND '19970228'

SELECT *
INTO P199703_Orders
FROM Orders
WHERE OrderDate BETWEEN '19970301' AND '19970331'

SELECT *
INTO P199704_Orders
FROM Orders
WHERE OrderDate BETWEEN '19970401' AND '19970430'

SELECT *
INTO P199705_Orders
FROM Orders
WHERE OrderDate BETWEEN '19970501' AND '19970531'

SELECT *
INTO P199706_Orders
FROM Orders
WHERE OrderDate BETWEEN '19970601' AND '19970630'

SELECT *
INTO P199707_Orders
FROM Orders
WHERE OrderDate BETWEEN '19970701' AND '19970731'

SELECT *
INTO P199708_Orders
FROM Orders
WHERE OrderDate BETWEEN '19970801' AND '19970831'

SELECT *
INTO P199709_Orders
FROM Orders
WHERE OrderDate BETWEEN '19970901' AND '19970930'

SELECT *
INTO P199710_Orders
FROM Orders
WHERE OrderDate BETWEEN '19971001' AND '19971031'

SELECT *
INTO P199711_Orders
FROM Orders
WHERE OrderDate BETWEEN '19971101' AND '19971130'

SELECT *
INTO P199712_Orders
FROM Orders
WHERE OrderDate BETWEEN '19971201' AND '19971231'

-- Now let's run a couple queries to see the effects of the partitioning
SELECT CONVERT(char(6), OrderDate, 112) OrderMonth, COUNT(*) NumOrders
FROM Orders
WHERE OrderDate BETWEEN '19970701' AND '19970731'
GROUP BY CONVERT(char(6), OrderDate, 112)
ORDER BY OrderMonth

ALTER TABLE P199707_Orders ADD CONSTRAINT PK_P199707_Orders PRIMARY KEY (OrderID)

SELECT CONVERT(char(6), OrderDate, 112) OrderMonth, COUNT(*) NumOrders
FROM P199707_Orders
WHERE OrderDate BETWEEN '19970701' AND '19970731'
GROUP BY CONVERT(char(6), OrderDate, 112)
ORDER BY OrderMonth

GO
ROLLBACK TRAN  -- Undo it
